require 'tdlib/version'
require 'ffi'
require 'json'

module TDLib
  extend FFI::Library
  def TDLib.loadLibrary(path = 'libtdjson.so')
    ffi_lib path
    attach_function :td_json_client_create, [], :pointer
    attach_function :td_json_client_receive, [:pointer, :double], :string
    attach_function :td_json_client_send, [:pointer, :string], :pointer
    attach_function :td_json_client_execute, [:pointer, :string], :string
    attach_function :td_json_client_destroy, [:pointer], :void
    attach_function :td_set_log_file_path, [:string], :int
    attach_function :td_set_log_max_file_size, [:long_long], :void
    attach_function :td_set_log_verbosity_level, [:int], :void
  end
end
